// TimerPage.cpp : implementation file
//

#include "stdafx.h"
#include "DiiDemo.h"
#include "TimerPage.h"
#include "DiiDemoDlg.h"

#include "Dii.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTimerPage property page

IMPLEMENT_DYNCREATE(CTimerPage, CPropertyPage)

CTimerPage::CTimerPage() : CPropertyPage(CTimerPage::IDD)
{
	//{{AFX_DATA_INIT(CTimerPage)
	m_dwTimerId = 0;
	m_dwTimerRate = 0;
	//}}AFX_DATA_INIT

	m_bIgnoreChange = TRUE;
}

CTimerPage::~CTimerPage()
{
}

void CTimerPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTimerPage)
	DDX_Control(pDX, IDC_TIMER_SPIN, m_timerSpin);
	DDX_Text(pDX, IDC_TIMER_ID, m_dwTimerId);
	DDX_Text(pDX, IDC_TIMER_RATE, m_dwTimerRate);
	//}}AFX_DATA_MAP

	if (!pDX->m_bSaveAndValidate)
	{
		m_timerSpin.SetRange (0,0xFF);

		m_timerSpin.SetPos (0);
	}
}


BEGIN_MESSAGE_MAP(CTimerPage, CPropertyPage)
	//{{AFX_MSG_MAP(CTimerPage)
	ON_EN_CHANGE(IDC_TIMER_RATE, OnChangeTimerRate)
	ON_EN_CHANGE(IDC_TIMER_ID, OnChangeTimerRate)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTimerPage message handlers

void CTimerPage::OnChangeTimerRate() 
{
	if (m_bIgnoreChange)
		return;

		//
		// Read in the data from the page:
		//
	UpdateData (TRUE);

		// ------------------------------------------------------------------
		//                        DII Library Calls:
		//
		// Our Task here:
		// Configure the specified timer to the new value:
		//
		// ------------------------------------------------------------------

	ASSERT (GetParent() && GetParent()->IsKindOf (RUNTIME_CLASS (CDiiDemoDlg)));

	if (DiiSetTimerConfig (	((CDiiDemoDlg *)GetParent())->GetDeviceHandle(),
							m_dwTimerId,
							0x04			// Set Mode 3 on 8253 chip.
							))
	{
		DiiLoadTimer (		((CDiiDemoDlg *)GetParent())->GetDeviceHandle(),
							m_dwTimerId,
							m_dwTimerRate
						);
	}
}

BOOL CTimerPage::OnKillActive() 
{
	m_bIgnoreChange	= TRUE;

	KillTimer (1);
	
	return CPropertyPage::OnKillActive();
}

BOOL CTimerPage::OnSetActive() 
{
	m_bIgnoreChange	= FALSE;

	VERIFY (SetTimer (1,20,NULL));

	return CPropertyPage::OnSetActive();
}

void CTimerPage::OnTimer(UINT nIDEvent) 
{
	DWORD dwValue = 0;

	if (DiiGetTimer (		((CDiiDemoDlg *)GetParent())->GetDeviceHandle(),
							m_dwTimerId,
							&dwValue ) )
	{
		char szTimerValue[11];

		ltoa (dwValue,szTimerValue,10);

		SetDlgItemText (IDC_TIMER_VALUE,szTimerValue);
	} else
	{
		SetDlgItemText (IDC_TIMER_VALUE,"N/A");
	}
	
	CPropertyPage::OnTimer(nIDEvent);
}

